library books_transfer;

import "package:struct_transfer/struct_transfer.dart";
import "dart:async";

BooksTransfer getBooksTransfer(Stream<String> in_data, void out_data(String str)) =>
  new BooksTransfer( new TransferBuilder(in_data,out_data) );
  

class BooksTransfer extends Transfer{
  
  final FromBookId fromBookId;
  final ToBookDetail toBookDetail;
  
  BooksTransfer(TransferBuilder tb):
    super(tb),
    fromBookId = new FromBookId(tb.getStructBuilder()),
    toBookDetail = new ToBookDetail(tb.getStructBuilder());
}

//sendはオーバーロードしてもしなくてもいい
class FromBookId extends Struct{
  
  final IntParam id;
  
  FromBookId(StructBuilder sb):
    super(sb),
    id = sb.intParam();

}

class ToBookDetail extends Struct{
  
  final StringParam title,author;
  final DateTimeParam publication;
  
  ToBookDetail(StructBuilder sb):
    super(sb),
    title = sb.stringParam(),
    author = sb.stringParam(),
        publication = sb.dateTimeParam();
  
  @override
  void send({String title , String author,DateTime publication}){
    this
        ..title.value = title
        ..author.value = author
        ..publication.value = publication;
    super.send();
  }
  
}