library books_transfer_client;

import "dart:html";
import "dart:async";
import "books.dart";

StreamController<String> in_data_sc = new StreamController<String>();
List <ButtonElement> buttons = new List.generate(3, createButton);
BooksTransfer bt;
WebSocket ws;

void main(){
  
  buttons.forEach((button) => document.body.append(button));
  ws = new WebSocket("ws://localhost:8888/");
  ws.onMessage.listen(onMessage);
  bt = getBooksTransfer(in_data_sc.stream, outData);
  
  bt.toBookDetail.onData.listen(onBookDetail);
  
  //ws.sendTypedData(data);
  
}

void onMessage(MessageEvent e){
  in_data_sc.add(e.data);
}

void outData(String str){
  ws.send(str);
  
}

void onClick(int id){
  bt.fromBookId
    ..id.value = id
    ..send();
}

ButtonElement createButton(int i) => 
    new ButtonElement()
      ..onClick.listen((e) => onClick(i))
      ..text = i.toString();

void onBookDetail(e){
  
  document.body.append(
      new DivElement()
        ..append(textSpan(bt.toBookDetail.title.value))
        ..append(textSpan(bt.toBookDetail.author.value)))
        ..append(textSpan(bt.toBookDetail.publication.value.toString()));
  
}

SpanElement textSpan(String str) => new SpanElement()..text = str;