library books_transfer_server;

import "dart:io";
import "dart:async";
import "books.dart";

void main(){
  HttpServer.bind("localhost", 8888).then(onBind);
}

void onBind(HttpServer server){
  server.listen(onRequest);
}
  
void onRequest(HttpRequest req){
  if(WebSocketTransformer.isUpgradeRequest(req)){
    WebSocketTransformer.upgrade(req).then((ws) => new Connection(ws));
  }
}

class Connection{
  
  final WebSocket ws;
  final to_transfer = new StreamController<String>();
  
  BooksTransfer bt;
  
  Connection(this.ws){
    
    bt = getBooksTransfer(to_transfer.stream, onFromTransferData);
    ws.listen(onWebSokcetData);
    bt.fromBookId.onData.listen(onBookId);
    
  }
  
  void onWebSokcetData(String str){
    to_transfer.add(str);
    
  }
  
  void onFromTransferData(String str){
    ws.add(str);
    
  }
  
  
  void onBookId(e){
    switch(bt.fromBookId.id.value){
      case 0 : 
        sendBookDetail("夏への扉","ロバート・A・ハインライン",new DateTime(1970,7,3));
        break;
      case 1 :
        sendBookDetail("われはロボット","アイザック・アシモフ",new DateTime(1968,9,1));
        break;
      case 2 :
        sendBookDetail("2001年宇宙の旅","アーサー・C・クラーク",new DateTime(1968,7,1));
        break;
    }
    
  }
  
  void sendBookDetail(String title,String author,DateTime publication){
    bt.toBookDetail.send(title : title, author : author,publication: publication);
    
  }
  
}